#ifndef __MYSTRING_H__
#define __MYSTRING_H__

class mystring
{
  char *data;
public:
  class index_out_of_range{};
  mystring ():data (0)
  {
  };
  ~mystring ()
  {
    delete[]data;
  };
  mystring (const char *s)
  {
    if (s)
      {
	data = new char[strlen (s) + 1];
	strcpy (data, s);
      }
    else
      data = 0;
  };

  unsigned int length () const
  {
    if (!data)
      return 0;
    else
      return strlen (data);
  }

  mystring (const mystring & src)
  {
    if (src.data)
      {
	data = new char[strlen (src.data) + 1];
	strcpy (data, src.data);
      }
    else
      data = 0;
  };
  mystring & operator= (const mystring & src)
  {
    if (this != &src)
      {
	char* newdata;
	if (src.data)
	  {
	    newdata = new char[strlen (src.data) + 1];
	    strcpy (newdata, src.data);
	  }
	else
	  newdata = 0;
	delete [] data;
	data=newdata;
      };
    return *this;
  }

  mystring & operator+= (const mystring & src)
  {
    char *newstr = new char[length () + src.length () + 1];
    if (length ())
      strcpy (newstr, data);
    else
      newstr[0] = '\0';
    if (src.length ())
      strcat (newstr, src.data);
    delete[]data;
    data = newstr;
    return *this;
  }


  char operator[] (unsigned int i) const
  {
    if (!data)
      throw index_out_of_range();
    if (i >= strlen (data))
      throw index_out_of_range();
    return data[i];
  }
  char &operator[] (unsigned int i)
  {
    if (!data)
      throw index_out_of_range();
    if (i >= strlen (data))
      throw index_out_of_range();
    return data[i];
  }

  friend ostream & operator<< (ostream & o, const mystring & s)
  {
    if (s.data)
      o << s.data;
    return o;
  }


};

  inline mystring operator+ (const mystring & s1, const mystring & s2)
  {
    mystring s (s1);
    return s += s2;
  }


#endif /* __MYSTRING_H__ */
